.nolist
include \masm32\include\masm32rt.inc
; include \masm32\MasmBasic\MasmBasic.inc 
.686
.xmm
include \masm32\macros\timers.asm
LOOP_COUNT	= 1000000

.data
Src1	dd 123
Src2	dd 41
fSrc1	REAL4	123.0
fSrc2	REAL4	41.0
fDest	REAL4	123.456
f8Src1	REAL8	123.0
f8Src2	REAL8	41.0
f8Dest	REAL8	123.456

.data?
Dest	dd ?

.code
start:	push 1
	call ShowCpu

;	call div32E
;	Print Str$("Res=%f\n", f8Dest)

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		call div32A
	counter_end
	print str$(eax), 9, "cycles for div32A, div", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		call div32B
	counter_end
	print str$(eax), 9, "cycles for div32B, fdiv", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		call div32C
	counter_end
	print str$(eax), 9, "cycles for div32C, fdiv", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		call div32D
	counter_end
	print str$(eax), 9, "cycles for div32D, divss", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		call div32E
	counter_end
	print str$(eax), 9, "cycles for div32E, divsd", 13, 10

	inkey chr$(13, 10, "--- ok ---", 13)
	exit

div32A proc
  mov eax, Src1
  cdq
  div Src2
  ret
div32A endp

div32B proc
  push Src1
  fild dword ptr [esp]
  push Src2
  fild dword ptr [esp]
  fdiv
  pop eax
  fistp dword ptr [esp]
  pop eax
  ret
div32B endp

div32C proc
  fild Src1
  fild Src2
  fdiv
  fistp Dest
  ret
div32C endp

div32D proc
  movss xmm1, fSrc1
  divss xmm1, fSrc2
  movss fDest, xmm1
  ret
div32D endp

div32E proc
  movsd xmm1, f8Src1
  divsd xmm1, f8Src2
  movsd f8Dest, xmm1
  ret
div32E endp

push 1
call ShowCpu
ShowCpu proc		; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h		; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h			; cpuid 1
  xor ebx, ebx					; CpuSSE
  xor esi, esi					; add zero plus the carry flag
  bt edx, 25					; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26					; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi					; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9						; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]				; dec mode in stack
  .if Zero?
	mov edi, esp							; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	print edi								; CpuBrand
	.if ebx
		print chr$(32, 40, "SSE")		; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10		; 41=)
	.endif
  .endif
  add esp, 80				; discard brand buffer (after printing!)
  mov [esp+32-4], ebx		; move ebx into eax stack position - returns eax to main for further use
  popad
  ret 4
ShowCpu endp

end start

RichMasm options:
OPT_Tmp2Asm	1
OPT_Wait	0
